/* This file was generated by Contract AspectJ v0.1 on Sat Nov 06 14:12:10 EST 2004 */
package jsim.queue;


public class TemporalQueue extends PriorityQueue{
	
	public TemporalQueue(){
		super();
		
	}
	
	public TemporalQueue(int capacity){
		super(capacity);
		/* @pre{this.capacity>0} */
		
	}
	
	public Q_Node enqueue(Object item){
		/* @pre{item!=null} */
		return enqueue(item,(double)System.currentTimeMillis(),Thread.NORM_PRIORITY);
		
	}
	
	public Q_Node enqueue(Object item,int priority){
		/* @pre{this.size<this.capacity&&item!=null&&priority>=0} */
		return enqueue(item,(double)System.currentTimeMillis(),priority);
		
	}
	
	public Q_Node enqueue(Object item,double time,int priority){
		/* @pre{this.size<this.capacity&&item!=null&&priority>=0} */
		TQ_Node newNode=new TQ_Node(item,time,priority);
		if(root!=null){
			splayForInsert(newNode);
			if(newNode.compare((TQ_Node)root)<0){
				newNode.left=root.left;
				newNode.right=root;
				root.left=null;
				
			}
			else{
				newNode.left=root;
				newNode.right=root.right;
				root.right=null;
				
			}
			
		}
		size++;
		return root=newNode;
		
	}
	
	protected void splayForInsert(TQ_Node newNode){
		/* @pre{newNode!=null} */
		TQ_Node lChild;
		TQ_Node rChild;
		for(;;){
			if(newNode.compare((TQ_Node)root)<0){
				if((lChild=(TQ_Node)root.left)==null)break;
				if(newNode.compare(lChild)<0){
					root=(TQ_Node)splayLeft(root,lChild);
					
				}
				else{
					if(lChild.right==null)break;
					lChild=(TQ_Node)splayRight(lChild,(TQ_Node)lChild.right);
					
				}
				
			}
			else if(newNode.compare(root)>=0){
				if((rChild=(TQ_Node)root.right)==null)break;
				if(newNode.compare(rChild)>0){
					root=(TQ_Node)splayRight(root,rChild);
					
				}
				else{
					if(rChild.left==null)break;
					lChild=(TQ_Node)splayLeft(rChild,rChild.left);
					
				}
				
			}
			
		}
		
	}
	
}
